<?php

/**
 * @file
 * Include functions for the wow module.
 */

class WoWException extends Exception {
  protected $request;
  protected $data;
  protected $protocol;
  protected $headers;
  protected $error;

  /**
   * Constructor.
   */
  public function __construct($response) {
    parent::__construct(isset($response->error) ? $response->error : $response->status_message, $response->code);
    $this->request = $response->request;
    if (isset($response->data)) {
      $this->data = json_decode($response->data);
    }
    if (isset($response->protocol)) {
      $this->protocol = $response->protocol;
    }
    if (isset($response->headers)) {
      $this->headers = $response->headers;
    }
    if (isset($response->error)) {
      $this->error = $response->error;
    }
  }

  /**
   * Return request.
   */
  public function getRequest() {
    return $this->request;
  }

  /**
   * Return data.
   */
  public function getData() {
    return $this->data;
  }

  /**
   * Return protocol.
   */
  public function getProtocol() {
    return $this->protocol;
  }

  /**
   * Return headers.
   */
  public function getHeaders() {
    return $this->headers;
  }

  /**
   * Return error.
   */
  public function getError() {
    return $this->error;
  }
}
